package ita.trem.app;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;

import java.security.MessageDigest;

import java.util.LinkedList;
import java.util.List;


public class TremMapListProvider
{
  
  
  public static List<Mappa> getMapList() throws TremMapListProviderException {
  
    List<Mappa> listaMappe = new LinkedList<Mappa>();
    URLConnection urlconn;
    URL url = null;
    InputStream is;
    
    try {
            url = new URL(TremDownloader.listUrl + "maps.log");
    } catch (MalformedURLException e) { /* Impossibile */ }

    
    try {
            urlconn = url.openConnection();
    } catch (IOException e) {
            //gui.setLog("Connection to server failed. Aborting..." + (char) 10 + (char) 13);
            throw new TremMapListProviderException("Connection to server failed. Aborting..." + (char) 10 + (char) 13);
    }
    
    try {
            is = urlconn.getInputStream();
    } catch (IOException e) {
            //gui.setLog("List retrieval failed. Aborting..." + (char) 10 + (char) 13);
            throw new TremMapListProviderException( "List retrieval failed. Aborting..." + (char) 10 + (char) 13);
    }

    BufferedReader buff = new BufferedReader(new InputStreamReader(is));
    
    String line = null;
    try {
      do {
              String nome;
              String vers;
              String fileServer;
              String pkfile;
              String sum;
              nome = buff.readLine();
              vers = buff.readLine();
              fileServer = buff.readLine();
              pkfile = buff.readLine();
              sum=buff.readLine();
              /* Crea oggetto mappa */
              listaMappe.add(new Mappa(nome,vers,pkfile,fileServer,sum));
              /* */
              line = buff.readLine();
      } while (line != null);
    } catch (IOException e) {
        if (listaMappe.size()==0) {
          //gui.setLog("List processing failed. Aborting..." + (char) 10 + (char) 13);
          throw new TremMapListProviderException("List processing failed. Aborting..." + (char) 10 + (char) 13);
        } else {
          //gui.setLog("Some troubles on parsing file, but some maps found..." + (char) 10 + (char) 13);
          throw new TremMapListProviderException("Some troubles on parsing file, but some maps found..." + (char) 10 + (char) 13);
        }
    } 
  
    return listaMappe;
  
  }
  
  public static String calcMD5(File locale) {
    try {
      MessageDigest md5 = MessageDigest.getInstance("MD5");
      byte[] b = new byte[4*1024];
      InputStream insock = new FileInputStream(locale);

      int lunghezza = insock.read(b);

      while (lunghezza > 0 ) {
                      md5.update(b,0,lunghezza);
                      lunghezza = insock.read(b);
      }
      insock.close();
      byte[] res = md5.digest();
      String output = TremDownloader.formatta(res);
      return output;
    } catch (Exception e) { e.printStackTrace(); return ""; }
  }
  
}
