package ita.trem.gui;

import ita.trem.app.Mappa;
import ita.trem.app.TremMapListProvider;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.io.File;

import java.util.List;

import javax.swing.JFrame;


public class MapLocalCheckRunner implements Runnable
{
  private MapSelectionTableModel model;
  private List<Mappa> listaMappe;
  private String localFilePath;
  private JFrame parent;
  private boolean stopRunning=false;

  public MapLocalCheckRunner(MapSelectionTableModel model, List<Mappa> listaMappe, String localFilePath, JFrame parent) {
    this.model=model;
    this.listaMappe=listaMappe;
    this.localFilePath=localFilePath;
    this.parent=parent;
  }
    
  public void run(){
    ProgressBarDialog dlg = ProgressBarDialog.getProgressBarDialog(parent, "",  model.getRowCount(), ProgressBarDialog.LOCAL_FILE_CHECK_PROGRESS_DIALOG) ;
    dlg.addCancelButtonActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        stopRunning=true;
      }
    });
    
    for (int i =0; i < model.getRowCount() && !stopRunning; i++){
    
      String separator = System.getProperty("file.separator");
      File localFile = new File(localFilePath+separator+String.valueOf(model.getValueAt(i, 3))); 
      if (localFile.exists()){
        String md5sum = TremMapListProvider.calcMD5(localFile);
        if (md5sum.equals(listaMappe.get(i).getMD5())){
          model.setValueAt("Up to date", i, 5);
        }
        else{
          model.setValueAt("Bad version", i, 5);
        }
      }
      else{
        model.setValueAt("Missing", i, 5);
      }
      dlg.setBarValue(i);  
      
    }
    stopRunning = false;
    dlg.setVisible(false);
  }
  
  
}
