package ita.trem.gui;

import ita.trem.app.Mappa;
import ita.trem.app.MappaComparator;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import java.io.IOException;

import java.net.MalformedURLException;

import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;


public class MapSelectionFrame
  extends JFrame implements ActionListener
{
  private BorderLayout borderLayout1 = new BorderLayout();
  private JScrollPane jsp = new JScrollPane();
  private JPanel buttonsPnl = new JPanel();
  private JPanel selectButtonsPnl = new JPanel();
  private JPanel centerPnl = new JPanel();
  private JTable table = new JTable();
  private MapSelectionTableModel model = new MapSelectionTableModel();
  private JButton butOk= new JButton();
  private JButton butCancel= new JButton();
  private JButton butCheck= new JButton();
  private JButton butAll= new JButton();
  private JButton butNone= new JButton();
  private JButton butMissing= new JButton();
  private JButton butBad= new JButton();
  private List<Mappa> listaMappe;
  private TremDownloaderGui gui;
  private List<Mappa> returnList =  new LinkedList();
  private MappaComparator mappeComparator= new MappaComparator();
  private String localFilePath;
  
  private static MapSelectionFrame dlg;

  public MapSelectionFrame(JFrame parent, List<Mappa> listaMappe, String localFilePath)  throws IOException {
    super();
    this.listaMappe=listaMappe;
    this.localFilePath=localFilePath;
    jbInit();
  }
  
  // Metodo per ottenere l'istanza unica di MapSelectionFrame ( pattern Singleton)
  public static List<Mappa> showMapSelectionFrame(List<Mappa> listaMappe  , TremDownloaderGui gui, String localFilePath) throws IOException {
    if(dlg == null){
      dlg = new MapSelectionFrame(gui, listaMappe,localFilePath);
      dlg.gui=gui;
    }
    
    try  {
      dlg.popolaTableModel();
      dlg.impostaAspettoColonne();      
    }
    catch(MalformedURLException muex){
      // Qui non dovrebbe mai entrare per cui lo gestisco qui direttamente invece di fare throw a livello superiore.
      muex.printStackTrace();
    }
    dlg.gui.getJButton4().setEnabled(false);
    dlg.setVisible(true);
    
    
    return dlg.returnList;
  }
 
  //Inizializzazione 
  private void jbInit() throws IOException
   
  {
    butOk.setText("Download selected maps");
    butOk.setActionCommand("download");
    butOk.addActionListener(this);
    butOk.setFont(new Font("Dialog", 0, 11));
    
    butCancel.setText("Close Window");
    butCancel.setActionCommand("cancel");
    butCancel.addActionListener(this);
    butCancel.setFont(new Font("Dialog", 0, 11));
    
    
    butCheck.setText("Check local maps");
    butCheck.setActionCommand("verifica");
    butCheck.addActionListener(this); 
    butCheck.setFont(new Font("Dialog", 0, 11));
    
    butAll.setText("Select all");
    butAll.setActionCommand("all");
    butAll.addActionListener(this);
    butAll.setFont(new Font("Dialog", 0, 11));
    
    butNone.setText("Select none");
    butNone.setActionCommand("none");
    butNone.addActionListener(this);
    butNone.setFont(new Font("Dialog", 0, 11));
    
    butBad.setText("Select bad version maps");
    butBad.setActionCommand("bad");
    butBad.addActionListener(this);
    butBad.setFont(new Font("Dialog", 0, 11));
    
    butMissing.setText("Select Missing maps");
    butMissing.setActionCommand("missing");
    butMissing.addActionListener(this);
    butMissing.setFont(new Font("Dialog", 0, 11));

    buttonsPnl.setLayout(new FlowLayout());
    buttonsPnl.add(butOk);
    buttonsPnl.add(butCheck);
    buttonsPnl.add(butCancel);    
    buttonsPnl.setBorder(BorderFactory.createEtchedBorder());
    
    selectButtonsPnl.setLayout(new GridBagLayout());
    selectButtonsPnl.setBorder(BorderFactory.createEtchedBorder());
    selectButtonsPnl.add(butAll, 
                         new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,GridBagConstraints.WEST, GridBagConstraints.NONE, 
                                                new Insets(5, 5, 5, 5), 0, 
                                                0));
    selectButtonsPnl.add(butMissing, 
                         new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, 
                                                new Insets(5, 0, 5, 5), 0, 
                                                0));    
    selectButtonsPnl.add(butBad, 
                         new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0,GridBagConstraints.WEST, GridBagConstraints.NONE, 
                                                new Insets(5, 0, 5, 5), 0, 
                                                0));    
    selectButtonsPnl.add(butNone, 
                         new GridBagConstraints(3, 0, 3, 1, 1.0, 0.0,GridBagConstraints.WEST, GridBagConstraints.NONE, 
                                                new Insets(5, 0, 5, 5), 0, 
                                                0));              
    
    centerPnl.setLayout(new BorderLayout());
    centerPnl.add(jsp, BorderLayout.CENTER);    
    centerPnl.add(selectButtonsPnl, BorderLayout.SOUTH);
    centerPnl.setBorder(BorderFactory.createLoweredBevelBorder());

    table.setFont(new Font("Dialog", 0, 11));

    jsp.setViewportView(table);
    jsp.setBorder(BorderFactory.createTitledBorder("Map List"));
    
    this.addWindowListener(new WindowAdapter(){
      public void windowClosing(WindowEvent e){
        gui.getJButton4().setEnabled(true);
      }
    });
    
    this.setFont(new Font("Dialog", 0, 11));
    this.getContentPane().setLayout(borderLayout1);
    this.setTitle("Map Selection");
    this.getContentPane().add(centerPnl, BorderLayout.CENTER);
    this.getContentPane().add(buttonsPnl, BorderLayout.SOUTH);
    this.setSize(new Dimension(600, 470));
    this.setLocation((Toolkit.getDefaultToolkit().getScreenSize().width - this.getWidth())/2, (Toolkit.getDefaultToolkit().getScreenSize().height - this.getHeight())/2);    
    
  }
  
  //Riempe il model della tabella coi dati.
  private void popolaTableModel()
    throws MalformedURLException, IOException
  {
    Collections.sort(listaMappe, mappeComparator); 
    //Object[][] tableData = new Object[listaMappe.size()][7];
     Object[][] tableData = new Object[listaMappe.size()][6];
    
    for (int i=0 ; i< listaMappe.size() ;i++ )  {
      Mappa m = listaMappe.get(i);
      tableData[i][0] = Boolean.valueOf(true);
      tableData[i][1] = m.getNome();
      tableData[i][2] = m.getVersione();
      tableData[i][3] = m.getNomeFile();
      tableData[i][4] = "Not retrieved";
      tableData[i][5] = "Unknown";
      //tableData[i][6] = null;
    }
    
    model = new MapSelectionTableModel(tableData);
    table.setModel(model);
    
    if( MapSizeConfirmDialog.getMapSizeConfirmDialog(this) )
      caricaDimensioneMappe();
    
  }
  
  private void verificaMappe(){
    Thread t = new Thread(new MapLocalCheckRunner(model, listaMappe, localFilePath, this));
    t.start();
  }
  
  private void caricaDimensioneMappe()  {
    Thread t = new Thread(new MapSizeRunner(model, listaMappe, this));
    t.start();
  }
  
  //Imposta l'allineamento delle varie colonne della table.
  private void impostaAspettoColonne() {
    DefaultTableCellRenderer cellRendererCenterCol4 = new DefaultTableCellRenderer() ;
    cellRendererCenterCol4.setHorizontalAlignment(DefaultTableCellRenderer.RIGHT);
    table.getColumnModel().getColumn(4).setCellRenderer(cellRendererCenterCol4);
    
    DefaultTableCellRenderer cellRendererCenterCol5 = new StateColumnRenderer() ;
    cellRendererCenterCol5.setHorizontalAlignment(DefaultTableCellRenderer.CENTER);
    table.getColumnModel().getColumn(5).setCellRenderer(cellRendererCenterCol5);
    
    /*
    TableCellRenderer cellRendererCol6 = new JButtonRenderer() ;
    table.getColumnModel().getColumn(6).setCellRenderer(cellRendererCol6);
    table.getColumnModel().getColumn(6).setCellEditor(new JButtonEditor());
    table.getColumnModel().getColumn(6).setPreferredWidth(50);
    */
    table.getTableHeader().setReorderingAllowed(false);
    table.getTableHeader().setResizingAllowed(true);
    
    table.setAutoResizeMode(JTable.AUTO_RESIZE_LAST_COLUMN);
    table.getColumnModel().getColumn(0).setPreferredWidth(30);
    table.getColumnModel().getColumn(1).setPreferredWidth(70);
    table.getColumnModel().getColumn(2).setPreferredWidth(60);
    table.getColumnModel().getColumn(3).setPreferredWidth(200);
    table.getColumnModel().getColumn(4).setPreferredWidth(70);    
  }
  
  public void actionPerformed(ActionEvent e){
    //Pulsante download
    if (e.getActionCommand().equals("download")){
      returnList.clear();
      for (int i =0; i < listaMappe.size(); i++){
        for (int j =0; j < model.getRowCount(); j++){
          if ( ((Boolean)model.getValueAt(j, 0)) &&  listaMappe.get(i).getNome().equals( ((String)model.getValueAt(j, 1)) ) ){
            returnList.add(listaMappe.get(i));
          }
        }
      }
      gui.getJButton4().setEnabled(true);
      if (!returnList.isEmpty()){
        gui.startDownloader(returnList);
      }
      setVisible(false);
    }
    //Pulsante Verifica
    if (e.getActionCommand().equals("verifica")){
      verificaMappe();      
    }
    
    //Pulsante Cancel
    if (e.getActionCommand().equals("cancel")){
      returnList.clear();
      gui.getJButton4().setEnabled(true);
      this.setVisible(false);
    }
    
    //Pulsante Select All
    if (e.getActionCommand().equals("all")){
      for (int i =0 ;i < model.getRowCount() ;i++ ) 
      {
        model.setValueAt(Boolean.valueOf(true), i, 0);
      }
    }
    
    //Pulsante Select Missing
    if (e.getActionCommand().equals("missing")){
      for (int i =0 ;i < model.getRowCount() ;i++ ) 
      {
        if(String.valueOf(model.getValueAt(i, 5 )).startsWith("Missing") )
          model.setValueAt(Boolean.valueOf(true), i, 0);
        else
          model.setValueAt(Boolean.valueOf(false), i, 0);
      }
    }
    
    //Pulsante Select Bad MD5
    if (e.getActionCommand().equals("bad")){
      for (int i =0 ;i < model.getRowCount() ;i++ ) 
      {
        if(String.valueOf(model.getValueAt(i, 5 )).startsWith("Bad") )
          model.setValueAt(Boolean.valueOf(true), i, 0);
        else
          model.setValueAt(Boolean.valueOf(false), i, 0);
      }
    }
    
    //Pulsante Select None
    if (e.getActionCommand().equals("none")){
      for (int i =0 ;i < model.getRowCount() ;i++ ) 
      {
        model.setValueAt( Boolean.valueOf(false), i, 0);
      }
    }
  }
}

/*
class JButtonRenderer extends JButton
                           implements TableCellRenderer {
  ImageIcon icon = new ImageIcon("camera.gif");
  
  public JButtonRenderer() {super();    }

  public Component getTableCellRendererComponent(
                          JTable table, Object color,
                          boolean isSelected, boolean hasFocus,
                          int row, int column) {
      
      this.setBorderPainted(false);
      this.setIcon(icon);
      return this;
  }
}

class JButtonEditor extends AbstractCellEditor
                         implements TableCellEditor,
                                    ActionListener {
    JButton button;

    public JButtonEditor() {
        button = new JButton();
        ImageIcon icon = new ImageIcon(button.getClass().getResource("/camera.gif"));
        button.setIcon(icon);              
        button.addActionListener(this);
        button.setBorderPainted(true);
        
    }

    public void actionPerformed(ActionEvent e) {
      
      fireEditingStopped();
    }

    //Implement the one CellEditor method that AbstractCellEditor doesn't.
    public Object getCellEditorValue() {
        return button;
    }

    //Implement the one method defined by TableCellEditor.
    public Component getTableCellEditorComponent(JTable table,
                                                 Object value,
                                                 boolean isSelected,
                                                 int row,
                                                 int column) {
        return button;
    }
}
*/