package ita.trem.gui;

import javax.swing.JButton;
import javax.swing.table.AbstractTableModel;


public class MapSelectionTableModel extends AbstractTableModel
{
   
  private Object[][] data; 
  
  private String[] columnNames = new String[]{"Select", "Name", "Version", "File Locale", "Size", "State"/*, "Image"*/};
  
  public MapSelectionTableModel(){
    this(null);
  }
  
  public MapSelectionTableModel(Object[][] data)
  {
    this.data=data;
  }
  
  public int getRowCount(){
    if (data != null)
      return data.length;
    else
      return 0;
  }
  
  public int getColumnCount(){
    if (data != null && data.length > 0)
      return data[0].length;
    else
      return 0;
  }
  
  public Object getValueAt(int row, int column){
    if (data != null)
      return data[row][column];
    else
      return null;
  }
  
  public boolean isCellEditable(int row, int col) {
    return col==0 || col == 6;
  }
  
  public Class getColumnClass(int col) {
    if (col == 0 )
      return Boolean.class;
    else
      if(col == 6)
        return JButton.class;
      else
        return String.class;
  }
  
  public String getColumnName(int col) {
      return columnNames[col];
  }
  
  public void setValueAt(Object value, int row, int col) {
          data[row][col] = value;
          fireTableCellUpdated(row, col);
      }
}
