package ita.trem.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;

import java.awt.FlowLayout;
import java.awt.Font;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;


public class MapSizeConfirmDialog
  extends JDialog implements ActionListener
{
  
  private static MapSizeConfirmDialog dlg;
  
  private JFrame parent;
  private boolean hasToBeShown=true;
  private boolean retValue=true;
  private JButton butOk = new JButton();
  private JButton butCancel = new JButton();
  private JCheckBox chkBox = new JCheckBox();
  private JLabel msgLabel = new JLabel();
  private JPanel panelButtons = new JPanel();
  private JPanel panelCenter = new JPanel();
  
  public MapSizeConfirmDialog(JFrame parent, String title, boolean modal)
  {
    super(parent, title, modal);
    this.parent = parent;
    jbInit();
  }
  
  public static boolean getMapSizeConfirmDialog(JFrame parent) {
    if(dlg == null){
      dlg = new MapSizeConfirmDialog(parent, "Confirm retrieving map files size", true);
    }
    if(dlg.hasToBeShown)
      dlg.setVisible(true);
    return dlg.retValue;
  }

  private void jbInit()  {
    butOk.setText("Yes");
    butOk.setActionCommand("yes");
    butOk.addActionListener(this);
    butOk.setFont(new Font("Dialog", 0, 11));
    
    butCancel.setText("No");
    butCancel.setActionCommand("no");
    butCancel.addActionListener(this);
    butCancel.setFont(new Font("Dialog", 0, 11));
    
    chkBox.setFont(new Font("Dialog", 0, 11));
    chkBox.setText("Remember choice");
    chkBox.setSelected(false);
    
    msgLabel.setText("Retrieving map files size could take a while to complete, proceed anyway ?");
    msgLabel.setFont(new Font("Dialog", 0, 11));
    
    panelCenter.setLayout(new GridBagLayout());
    panelCenter.setBorder(BorderFactory.createEtchedBorder());
    panelCenter.add(msgLabel, 
                             new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,GridBagConstraints.CENTER, GridBagConstraints.NONE, 
                                                    new Insets(5, 5, 5, 5), 0, 
                                                    0));
    panelCenter.add(chkBox, 
                             new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,GridBagConstraints.CENTER, GridBagConstraints.NONE, 
                                                    new Insets(5, 5, 5, 5), 0, 
                                                    0));
    
    panelButtons.setLayout(new FlowLayout());
    panelButtons.add(butOk);
    panelButtons.add(butCancel);
    panelButtons.setBorder(BorderFactory.createEtchedBorder());
    
    this.setResizable(false);
    this.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
    this.getContentPane().setLayout( new BorderLayout() );
    this.getContentPane().add(panelButtons, BorderLayout.SOUTH);
    this.getContentPane().add(panelCenter, BorderLayout.CENTER);
    this.setSize( new Dimension( 380, 120 ) );
    this.setLocation(Double.valueOf(parent.getLocation().getX()).intValue() +  (parent.getWidth() - this.getWidth())/2, Double.valueOf(parent.getLocation().getY()).intValue()  + (parent.getHeight() - this.getHeight())/2 );
  }
  
  public void actionPerformed(ActionEvent e){
    if (e.getActionCommand().equals("yes")){
      retValue = true;
    }
    if (e.getActionCommand().equals("no")){
      retValue = false;
    }
    
    if (chkBox.isSelected()){
      hasToBeShown = false;
    }
    
    setVisible(false);
  }
}
