package ita.trem.gui;

import ita.trem.app.Mappa;
import ita.trem.app.TremDownloader;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.io.IOException;

import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;

import java.text.DecimalFormat;

import java.util.List;

import javax.swing.JFrame;


public class MapSizeRunner implements Runnable
{

  private DecimalFormat formatter = new DecimalFormat("###,###,###");
  private MapSelectionTableModel model;
  private JFrame parent;
  private List<Mappa> listaMappe;
  private boolean stopRunning = false;

  public MapSizeRunner(MapSelectionTableModel model, List<Mappa> listaMappe, JFrame parent) {
    this.model=model;
    this.parent=parent;
    this.listaMappe=listaMappe;
  }
    
  public void run(){
    
    ProgressBarDialog dlg = ProgressBarDialog.getProgressBarDialog(parent,"", model.getRowCount()-1, ProgressBarDialog.FILE_SIZE_PROGRESS_DIALOG);
    dlg.addCancelButtonActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        stopRunning=true;
      }
    });
    
    for (int i=0 ; i< model.getRowCount() && !stopRunning;i++ )  {
      String dimensione="";
      try 
      {
        dimensione = formatter.format( getDimensioneMappa(listaMappe.get(i).getFileSulServer()) );  
      } catch (IOException ioex) 
      {
        dimensione = "Error getting file size";
      } 
      
      model.setValueAt(dimensione, i, 4);
      dlg.setBarValue(i);
    }
    stopRunning = false;
    dlg.setVisible(false);
  }
  
  // Ritorna la dimensione in bytes del file della mappa sul server 
  private int getDimensioneMappa(String nomeFile)
    throws IOException
  {
    int ret=-1;
    try{
      URL mappaUrl = new URL(TremDownloader.listUrl + nomeFile);
      URLConnection conn = mappaUrl.openConnection();
      ret =conn.getContentLength();
    }
    catch(MalformedURLException mex){/*Impossibile*/}
    
    
    return ret;
  }
}
