package ita.trem.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JProgressBar;


public class ProgressBarDialog
  extends JDialog
{
  private BorderLayout borderLayout1 = new BorderLayout();
  private JProgressBar bar = new JProgressBar();
  private int tipo;
  private String borderTitle = "";
  private JButton butStop = new JButton();
  private JPanel butPanel = new JPanel();
  private static ProgressBarDialog dlg;
  
  public final static int DOWNLOAD_PROGRESS_DIALOG=0;
  public final static int FILE_SIZE_PROGRESS_DIALOG=1;
  public final static int LOCAL_FILE_CHECK_PROGRESS_DIALOG=2;
  
  public ProgressBarDialog(JFrame parent, int tipo){
    super(parent, false);
    init();
  }
  
  // Metodo per ottenere l'istanza unica di ProgressBarDialog ( pattern Singleton)
  public static ProgressBarDialog getProgressBarDialog(JFrame parent, String nomeFile, int max, int tipo){
    if (dlg == null){
      dlg = new ProgressBarDialog(parent, tipo);
    }
    dlg.tipo=tipo;
    dlg.setupDlg(parent, nomeFile, max);
    dlg.setVisible(true);
    
    return dlg;
  }
  
  
  
  //Imposta i dati specifici della mappa , dimensione e nome
  private void setupDlg(JFrame frm, String nomeFile, int max){
    
    switch(tipo){
      case DOWNLOAD_PROGRESS_DIALOG:{
        this.setTitle("Downloading map: "+nomeFile);
        borderTitle= "Download Progress:";
        break;
      }
      case FILE_SIZE_PROGRESS_DIALOG:{
        this.setTitle("Retrieving map files size");
        borderTitle= "Progress:";
        break;
      }
      case LOCAL_FILE_CHECK_PROGRESS_DIALOG:{
        this.setTitle("Checking files");
        borderTitle= "Progress:";
        break;
      }
    }
    
    bar.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder(borderTitle), BorderFactory.createEtchedBorder() ));
    this.setLocation(Double.valueOf(frm.getLocation().getX()).intValue() +  (frm.getWidth() - this.getWidth())/2, Double.valueOf(frm.getLocation().getY()).intValue()  + (frm.getHeight() - this.getHeight())/2 );
    bar.setMaximum(max);
  }
  
  
  
  //Inizializzazione 
  private void init(){
    bar.setStringPainted(true);
    bar.setMinimum(0);
    bar.setFont(new Font("Dialog", 0, 11));
    
    butStop.setText("Stop");
    butStop.setFont(new Font("Dialog", 0, 11));
    
    butPanel.setLayout(new FlowLayout());
    butPanel.add(butStop);
    
    this.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
    this.getContentPane().setLayout(borderLayout1);
    this.getContentPane().add(bar, BorderLayout.CENTER);
    this.getContentPane().add(butPanel, BorderLayout.SOUTH);
    this.setSize(new Dimension(400, 110));    
  }

  
  public void setBarValue(int val){
    bar.setValue(val);
  }
  
  public void addCancelButtonActionListener(ActionListener listener){
    for (int i =0 ;i <  butStop.getActionListeners().length;i++ ) 
    {
      butStop.removeActionListener(butStop.getActionListeners()[i]);
    }    
    butStop.addActionListener(listener);
  }
}
