/* Created on 25-ago-2006 */
package ita.trem.gui;

import ita.trem.app.Mappa;
import ita.trem.app.TremDownloader;
import ita.trem.app.TremMapListProvider;
import ita.trem.app.TremMapListProviderException;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Toolkit;

import java.io.File;
import java.io.IOException;

import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuBar;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.border.BevelBorder;


public class TremDownloaderGui extends JFrame {

	private JFrame jFrame;  //  @jve:decl-index=0:visual-constraint="149,10"

	private JPanel jContentPane;

	private JMenuBar jJMenuBar;

	private JPanel jPanel = null;

	private JButton jButton = null;

	private JButton jButton1 = null;

	private JButton jButton2 = null;
        
 private JButton jButton4 = null;

	private JPanel jPanel1 = null;

	private JLabel jLabel = null;

	private JTextField jTextField = null;

	private JButton jButton3 = null;

	private JPanel jPanel2 = null;

	private JScrollPane jScrollPane = null;

	private JTextArea jTextArea = null;

	private JFileChooser jFileChooserScegli;

	private JCheckBox jCheckBox = null;

	private JCheckBox jCheckBox1 = null;

	private JCheckBox jCheckBox2 = null;

	private JCheckBox jCheckBox3 = null;

	private JCheckBox jCheckBox4 = null;

	private JCheckBox jCheckBox5 = null;
	
	private TremDownloader app = null;
        
        private List<Mappa> selectedMaps = null;
        
        private boolean isApplet=false;

	/**
	 * This method initializes 
	 * 
	 */
	public TremDownloaderGui(boolean isApplet) {
		super();
                this.isApplet=isApplet;
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
        this.setSize(new Dimension(214, 21));
			
	}

	public void setLog(String text) {
		this.jTextArea.append(text);
	}
	
	/** 
	 * Metodi per il set dei checkbox
	 * 
	 */
	
	public void setServerConnection(boolean what) {
		this.jCheckBox.setSelected(what);
	}
	
	public void setListFetch(boolean what) {
		this.jCheckBox1.setSelected(what);
	}
	
	public void setListProcess(boolean what) {
		this.jCheckBox2.setSelected(what);
	}
	
	public void setMapUpdate(boolean what) {
		this.jCheckBox3.setSelected(what);
	}
	
	public void setDeleteTemp(boolean what) {
		this.jCheckBox4.setSelected(what);
	}
	
	public void setDone(boolean what) {
		this.jCheckBox5.setSelected(what);
	}
	
	/**
	 * This method initializes jFrame
	 * 
	 * @return javax.swing.JFrame
	 */
	public JFrame getJFrame() {
		if (jFrame == null) {
			jFrame = new JFrame();
                        if (!isApplet)
                          jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
                          
			jFrame.setResizable(false);
			jFrame.setJMenuBar(getJJMenuBar());
			jFrame.setSize(535, 325);
                        //Metto il frame al centro dello schermo
                        jFrame.setLocation((Toolkit.getDefaultToolkit().getScreenSize().width - jFrame.getWidth())/2, (Toolkit.getDefaultToolkit().getScreenSize().height - jFrame.getHeight())/2);    
			jFrame.setContentPane(getJContentPane());
			jFrame.setTitle("Italian Tremulous Alliance - Map Downloader");
		}
		return jFrame;
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJPanel(), BorderLayout.SOUTH);
			jContentPane.add(getJPanel1(), BorderLayout.NORTH);
			jContentPane.add(getJPanel2(), BorderLayout.WEST);
			jContentPane.add(getJScrollPane(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jJMenuBar	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
		}
		return jJMenuBar;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
			jPanel.setLayout(new FlowLayout());
			jPanel.setPreferredSize(new Dimension(0, 35));
			jPanel.add(getJButton());
			jPanel.add(getJButton1());
			jPanel.add(getJButton2());
                        jPanel.add(getJButton4());
		}
		return jPanel;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setPreferredSize(new Dimension(120, 20));
			jButton.setText("Start update");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					startDownloader(null);
				}
			});
		}
		return jButton;
	}

	protected void startDownloader(List<Mappa> listaMappe) {
		this.app = new TremDownloader(this.jTextField.getText(),this, listaMappe);
		this.setServerConnection(false);
		this.setListFetch(false);
		this.setListProcess(false);
		this.setMapUpdate(false);
		this.setDeleteTemp(false);
		this.setDone(false);
		this.app.start();
	}
	
	protected void stopDownloader() {
		this.app.setToRun(false);
	}
	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setPreferredSize(new Dimension(120, 20));
			jButton1.setEnabled(false);
			jButton1.setText("Stop update");
			jButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					stopDownloader();
				}
			});
		}
		return jButton1;
	}

	/**
	 * This method initializes jButton2	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton2() {
		if (jButton2 == null) {
			jButton2 = new JButton();
			jButton2.setPreferredSize(new Dimension(120, 20));
			jButton2.setText("Quit");
			jButton2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
                                        if(!isApplet)
                                          System.exit(0);
                                        else
                                          jFrame.setVisible(false);
				}
			});
		}
		return jButton2;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jLabel = new JLabel();
			jLabel.setText("Directory to update");
			jLabel.setFont(new Font("Arial", Font.PLAIN, 12));
			jLabel.setPreferredSize(new Dimension(120, 20));
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setAlignment(FlowLayout.LEFT);
			jPanel1 = new JPanel();
			jPanel1.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
			jPanel1.setLayout(flowLayout);
			jPanel1.setPreferredSize(new Dimension(0, 35));
			jPanel1.add(jLabel, null);
			jPanel1.add(getJTextField(), null);
			jPanel1.add(getJButton3(), null);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setPreferredSize(new Dimension(200, 20));
			System.out.println(System.getProperty("os.name"));
			if (System.getProperty("os.name").toLowerCase().compareTo("linux") == 0) {
				jTextField.setText(System.getenv("HOME") + "/.tremulous/base");
			} else { // probabilmente windows
				jTextField.setText("C:\\Programmi\\tremulous\\base");
			}
		}
		return jTextField;
	}

	/**
	 * This method initializes jButton3	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton3() {
		if (jButton3 == null) {
			jButton3 = new JButton();
			jButton3.setPreferredSize(new Dimension(100, 20));
			jButton3.setText("Select...");
			jButton3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					showFileDialog();
				}
			});
		}
		return jButton3;
	}
        
  /**
   * This method initializes jButton4     
   *      
   * @return javax.swing.JButton  
   */
  public JButton getJButton4() {
          if (jButton4 == null) {
                  jButton4 = new JButton();
                  jButton4.setPreferredSize(new Dimension(110, 20));
                  jButton4.setText("Select Maps");
                  
                  //La seguente riga  necessaria, perche' altrimenti this dentro la definizione del listener si riferirebbe al listener stesso 
                  // e non al TremDownloaderGui
                  final TremDownloaderGui gui =this;
                  jButton4.addActionListener(new java.awt.event.ActionListener() {
                          public void actionPerformed(java.awt.event.ActionEvent e) {
                          
                              List<Mappa> listaMappe = null;
                              setLog("Getting map list from server." + (char) 10 + (char) 13);
                              
                              try 
                              {
                                listaMappe = TremMapListProvider.getMapList();  
                                setLog("Map list retrieved ." + (char) 10 + (char) 13); 
                                
                                // la chiamata per mostrare la finestra la metto qui cosi' se fallisce il download della lista non parte nemmeno.
                                MapSelectionFrame.showMapSelectionFrame(listaMappe, gui, jTextField.getText());
                                
                                
                              }
                              catch (TremMapListProviderException ex) 
                              {
                                setLog(ex.getMessage());  
                              } 
                              catch (IOException ioex) 
                              {
                                setLog("Map files size retrieving error; Map list could be empty or incomplete. " + (char) 10 + (char) 13);  
                              } 
                                                          
                          }
                  });
          }
          return jButton4;
  }

	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(6);
			gridLayout.setColumns(1);
			jPanel2 = new JPanel();
			jPanel2.setLayout(gridLayout);
			jPanel2.setPreferredSize(new Dimension(150, 0));
			jPanel2.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
			jPanel2.add(getJCheckBox(), null);
			jPanel2.add(getJCheckBox1(), null);
			jPanel2.add(getJCheckBox2(), null);
			jPanel2.add(getJCheckBox3(), null);
			jPanel2.add(getJCheckBox4(), null);
			jPanel2.add(getJCheckBox5(), null);
		}
		return jPanel2;
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTextArea());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextArea();
		}
		return jTextArea;
	}

	private JFileChooser getJFileChooserScegli() {
		if (jFileChooserScegli == null) {
			jFileChooserScegli = new JFileChooser();
			jFileChooserScegli.setPreferredSize(new java.awt.Dimension(400,300));
			jFileChooserScegli.setDialogType(JFileChooser.OPEN_DIALOG);	/*IMPORTANTE!!!!Con questo metodo si scelgono i bottoni del chooser! Tramite le costanti statiche */
			jFileChooserScegli.setDialogTitle("Choose File");
			jFileChooserScegli.setFileHidingEnabled(false);
			jFileChooserScegli.setSize(new java.awt.Dimension(400,300));
			jFileChooserScegli.setVisible(false);
		    }
		return jFileChooserScegli;
	}
	
	protected void showFileDialog() {
		getJFileChooserScegli();
		this.jFileChooserScegli.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		this.jFileChooserScegli.setDialogTitle("Choose directory to update");
		//this.jFileChooserScegli.show();
                this.jFileChooserScegli.setVisible(true);
		int ritorno = jFileChooserScegli.showOpenDialog(null);
	    if (ritorno == JFileChooser.APPROVE_OPTION) {	
	    	File toOpen = this.jFileChooserScegli.getSelectedFile();
	    	this.jTextField.setText(toOpen.getAbsolutePath());
	    }
	    else {
	    	jFileChooserScegli.setVisible(false);
	    }
	}
	
	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
			jCheckBox.setText("Server connection");
			jCheckBox.setEnabled(false);
			jCheckBox.setFont(new Font("Arial", Font.PLAIN, 12));
		}
		return jCheckBox;
	}

	/**
	 * This method initializes jCheckBox1	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCheckBox1() {
		if (jCheckBox1 == null) {
			jCheckBox1 = new JCheckBox();
			jCheckBox1.setText("Map list download");
			jCheckBox1.setEnabled(false);
			jCheckBox1.setFont(new Font("Arial", Font.PLAIN, 12));
		}
		return jCheckBox1;
	}

	/**
	 * This method initializes jCheckBox2	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCheckBox2() {
		if (jCheckBox2 == null) {
			jCheckBox2 = new JCheckBox();
			jCheckBox2.setText("Map list processing");
			jCheckBox2.setEnabled(false);
			jCheckBox2.setFont(new Font("Arial", Font.PLAIN, 12));
		}
		return jCheckBox2;
	}

	/**
	 * This method initializes jCheckBox3	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCheckBox3() {
		if (jCheckBox3 == null) {
			jCheckBox3 = new JCheckBox();
			jCheckBox3.setText("Map update");
			jCheckBox3.setEnabled(false);
			jCheckBox3.setFont(new Font("Arial", Font.PLAIN, 12));
		}
		return jCheckBox3;
	}

	/**
	 * This method initializes jCheckBox4	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCheckBox4() {
		if (jCheckBox4 == null) {
			jCheckBox4 = new JCheckBox();
			jCheckBox4.setText("Delete temp files");
			jCheckBox4.setEnabled(false);
			jCheckBox4.setFont(new Font("Arial", Font.PLAIN, 12));
		}
		return jCheckBox4;
	}

	/**
	 * This method initializes jCheckBox5	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCheckBox5() {
		if (jCheckBox5 == null) {
			jCheckBox5 = new JCheckBox();
			jCheckBox5.setText("Done");
			jCheckBox5.setEnabled(false);
			jCheckBox5.setFont(new Font("Arial", Font.BOLD, 12));
		}
		return jCheckBox5;
	}

	/**
	 * Launches this application
	 */
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				TremDownloaderGui application = new TremDownloaderGui(false);
				application.getJFrame().setVisible(true);
			}
		});
	}
	
	public void enableStop() {
		this.jButton.setEnabled(false);
		this.jButton1.setEnabled(true);
	}
	
	public void disableStop() {
		this.jButton1.setEnabled(false);
		this.jButton.setEnabled(true);
	}

  public void setSelectedMaps(List<Mappa> selectedMaps)
  {
    this.selectedMaps = selectedMaps;
  }
} //  @jve:decl-index=0:visual-constraint="10,10"
